Loading...
Searching...
No Matches
juce::MessageManager Class Referencefinal

`#include <juce_MessageManager.h>`

## Classes

class | MessageBase
class | Lock

## Public Member Functions

void | runDispatchLoop ()
void | stopDispatchLoop ()
bool | hasStopMessageBeenSent () const noexcept
void * | callFunctionOnMessageThread (MessageCallbackFunction *callback, void *userData)
bool | isThisTheMessageThread () const noexcept
void | setCurrentThreadAsMessageThread ()
Thread::ThreadID | getCurrentMessageThread () const noexcept
bool | currentThreadHasLockedMessageManager () const noexcept
void | registerBroadcastListener (ActionListener *listener)
void | deregisterBroadcastListener (ActionListener *listener)
void | deliverBroadcastMessage (const String &)

## Static Public Member Functions

static MessageManager * | getInstance ()
static MessageManager * | getInstanceWithoutCreating () noexcept
static void | deleteInstance ()
static bool | callAsync (std::function< void()> functionToCall)
static bool | existsAndIsLockedByCurrentThread () noexcept
static bool | existsAndIsCurrentThread () noexcept
static void | broadcastMessage (const String &messageText)

## Detailed Description

This class is in charge of the application's event-dispatch loop.

See also
  Message, CallbackMessage, MessageManagerLock, JUCEApplication, JUCEApplicationBase

Definition at line 44 of file juce_MessageManager.h.

## Constructor & Destructor Documentation

## ~MessageManager()

juce::MessageManager::~MessageManager | ( |  | ) |

noexcept

Definition at line 35 of file juce_MessageManager.cpp.

## Member Function Documentation

## broadcastMessage()

void juce::MessageManager::broadcastMessage | ( | const String & | messageText | ) |

static

Sends a message to all other JUCE applications that are running.

Parameters

  messageText | the string that will be passed to the actionListenerCallback() method of the broadcast listeners in the other app.

See also
  registerBroadcastListener, ActionListener

Referenced by broadcastMessage().

## callAsync()

bool juce::MessageManager::callAsync | ( | std::function< void()> | functionToCall | ) |

static

Asynchronously invokes a function or C++11 lambda on the message thread.

Returns
  true if the message was successfully posted to the message queue, or false otherwise.

Definition at line 195 of file juce_MessageManager.cpp.

## callFunctionOnMessageThread()

void * juce::MessageManager::callFunctionOnMessageThread | ( | MessageCallbackFunction * | callback,
|  | void * | userData )

Calls a function using the message-thread.

This can be used by any thread to cause this function to be called-back by the message thread. If it's the message-thread that's calling this method, then the function will just be called; if another thread is calling, a message will be posted to the queue, and this method will block until that message is delivered, the function is called, and the result is returned.

Be careful not to cause any deadlocks with this! It's easy to do - e.g. if the caller thread has a critical section locked, which an unrelated message callback then tries to lock before the message thread gets round to processing this callback.

Parameters

  callback | the function to call - its signature must be void* myCallbackFunction (void*)
  userData | a user-defined pointer that will be passed to the function that gets called

Returns
  the value that the callback function returns.

See also
  MessageManagerLock

Definition at line 175 of file juce_MessageManager.cpp.

## currentThreadHasLockedMessageManager()

bool juce::MessageManager::currentThreadHasLockedMessageManager | ( |  | ) | const

noexcept

Returns true if the caller thread has currently got the message manager locked.

see the MessageManagerLock class for more info about this.

This will be true if the caller is the message thread, because that automatically gains a lock while a message is being dispatched.

Definition at line 252 of file juce_MessageManager.cpp.

Referenced by callFunctionOnMessageThread().

## deleteInstance()

void juce::MessageManager::deleteInstance | ( |  | ) |

static

Deletes the global MessageManager instance. Does nothing if no instance had been created.

Definition at line 63 of file juce_MessageManager.cpp.

## deliverBroadcastMessage()

void juce::MessageManager::deliverBroadcastMessage | ( | const String & | value | ) |

Definition at line 208 of file juce_MessageManager.cpp.

## deregisterBroadcastListener()

void juce::MessageManager::deregisterBroadcastListener | ( | ActionListener * | listener | ) |

Deregisters a broadcast listener.

Definition at line 222 of file juce_MessageManager.cpp.

Referenced by broadcastMessage().

## existsAndIsCurrentThread()

bool juce::MessageManager::existsAndIsCurrentThread | ( |  | ) |

static noexcept

Returns true if there's an instance of the MessageManager, and if the current thread is running it.

Definition at line 266 of file juce_MessageManager.cpp.

## existsAndIsLockedByCurrentThread()

bool juce::MessageManager::existsAndIsLockedByCurrentThread | ( |  | ) |

static noexcept

Returns true if there's an instance of the MessageManager, and if the current thread has the lock on it.

Definition at line 258 of file juce_MessageManager.cpp.

## getCurrentMessageThread()

Thread::ThreadID juce::MessageManager::getCurrentMessageThread | ( |  | ) | const

inline noexcept

Returns the ID of the current message thread, as set by setCurrentThreadAsMessageThread().

(Best to ignore this method unless you really know what you're doing..)

See also
  setCurrentThreadAsMessageThread

Definition at line 134 of file juce_MessageManager.h.

Referenced by getCurrentMessageThread().

## getInstance()

MessageManager * juce::MessageManager::getInstance | ( |  | ) |

static

Returns the global instance of the MessageManager.

Definition at line 47 of file juce_MessageManager.cpp.

Referenced by juce::JUCEApplicationBase::quit().

## getInstanceWithoutCreating()

MessageManager * juce::MessageManager::getInstanceWithoutCreating | ( |  | ) |

static noexcept

Returns the global instance of the MessageManager, or nullptr if it doesn't exist.

Definition at line 58 of file juce_MessageManager.cpp.

Referenced by existsAndIsCurrentThread(), existsAndIsLockedByCurrentThread(), juce::AsyncUpdater::~AsyncUpdater(), and juce::Timer::~Timer().

## hasStopMessageBeenSent()

bool juce::MessageManager::hasStopMessageBeenSent | ( |  | ) | const

inline noexcept

Returns true if the stopDispatchLoop() method has been called.

Definition at line 80 of file juce_MessageManager.h.

## isThisTheMessageThread()

bool juce::MessageManager::isThisTheMessageThread | ( |  | ) | const

noexcept

Returns true if the caller-thread is the message thread.

Definition at line 229 of file juce_MessageManager.cpp.

Referenced by callFunctionOnMessageThread(), and runDispatchLoop().

## registerBroadcastListener()

void juce::MessageManager::registerBroadcastListener | ( | ActionListener * | listener | ) |

Registers a listener to get told about broadcast messages.

The actionListenerCallback() callback's string parameter is the message passed into broadcastMessage().

See also
  broadcastMessage

Definition at line 214 of file juce_MessageManager.cpp.

Referenced by broadcastMessage().

## runDispatchLoop()

void juce::MessageManager::runDispatchLoop | ( |  | ) |

Runs the event dispatch loop until a stop message is posted.

This method is only intended to be run by the application's startup routine, as it blocks, and will only return after the stopDispatchLoop() method has been used.

See also
  stopDispatchLoop

Definition at line 104 of file juce_MessageManager.cpp.

## setCurrentThreadAsMessageThread()

void juce::MessageManager::setCurrentThreadAsMessageThread | ( |  | ) |

Called to tell the manager that the current thread is the one that's running the dispatch loop.

(Best to ignore this method unless you really know what you're doing..)

See also
  getCurrentMessageThread

Definition at line 236 of file juce_MessageManager.cpp.

## stopDispatchLoop()

void juce::MessageManager::stopDispatchLoop | ( |  | ) |

Sends a signal that the dispatch loop should terminate.

After this is called, the runDispatchLoop() or runDispatchLoopUntil() methods will be interrupted and will return.

See also
  runDispatchLoop

Definition at line 119 of file juce_MessageManager.cpp.

Referenced by juce::JUCEApplicationBase::quit().

The documentation for this class was generated from the following files:

- juce_MessageManager.h
- juce_MessageManager.cpp